#include "list.h"
#include <cstddef>
#include <iostream>

List::List(): head_(nullptr), tail_(nullptr), size_(0) {}

List::~List() {
  while (head_ != nullptr) {
    ListNode *tmp = head_;
    head_ = head_->next;
    delete tmp;
  }
}

size_t List::front() const {
  return head_->val_;
}

size_t List::back() const {
  return tail_->val_;
}

size_t List::size() const{
  return size_;
}

void List::dump() const {
  ListNode *tmp = head_;
  for (int i = 0; i < size_; i++)
  {
    std::cout <<tmp->val_ << " ";
    tmp = tmp->next;
    if(tmp == nullptr){
      break;
    }
  }
  std::cout << std::endl;
  
}

void List::push_back(size_t val) {
  ListNode *node = new ListNode(val);
  if (head_ == nullptr) {
    head_ = node;
    tail_ = node;
  } else {
    tail_->next = node;
    tail_ = node;
  }
  size_++;
}

void List::pop_back() {
  if (head_ == nullptr) {
    return;
  }
  if (head_ == tail_) {
    delete head_;
    head_ = nullptr;
    tail_ = nullptr;
  } else {
    ListNode *tmp = head_;
    while (tmp->next != tail_) {
      tmp = tmp->next;
    }
    delete tail_;
    tail_ = tmp;
    tail_->next = nullptr;
  }
  size_--;
}
